#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private TradingRenkoSR[] cacheTradingRenkoSR;
		private TradingRenkoOZS[] cacheTradingRenkoOZS;
		private SVAPO[] cacheSVAPO;

		
		public TradingRenkoSR TradingRenkoSR(int strength)
		{
			return TradingRenkoSR(Input, strength);
		}

		public TradingRenkoOZS TradingRenkoOZS(int period, int longPeriod, int percent)
		{
			return TradingRenkoOZS(Input, period, longPeriod, percent);
		}

		public SVAPO SVAPO(int period, int cutoff, double devH, double devL, int stdDevPer)
		{
			return SVAPO(Input, period, cutoff, devH, devL, stdDevPer);
		}


		
		public TradingRenkoSR TradingRenkoSR(ISeries<double> input, int strength)
		{
			if (cacheTradingRenkoSR != null)
				for (int idx = 0; idx < cacheTradingRenkoSR.Length; idx++)
					if (cacheTradingRenkoSR[idx].Strength == strength && cacheTradingRenkoSR[idx].EqualsInput(input))
						return cacheTradingRenkoSR[idx];
			return CacheIndicator<TradingRenkoSR>(new TradingRenkoSR(){ Strength = strength }, input, ref cacheTradingRenkoSR);
		}

		public TradingRenkoOZS TradingRenkoOZS(ISeries<double> input, int period, int longPeriod, int percent)
		{
			if (cacheTradingRenkoOZS != null)
				for (int idx = 0; idx < cacheTradingRenkoOZS.Length; idx++)
					if (cacheTradingRenkoOZS[idx].Period == period && cacheTradingRenkoOZS[idx].LongPeriod == longPeriod && cacheTradingRenkoOZS[idx].Percent == percent && cacheTradingRenkoOZS[idx].EqualsInput(input))
						return cacheTradingRenkoOZS[idx];
			return CacheIndicator<TradingRenkoOZS>(new TradingRenkoOZS(){ Period = period, LongPeriod = longPeriod, Percent = percent }, input, ref cacheTradingRenkoOZS);
		}

		public SVAPO SVAPO(ISeries<double> input, int period, int cutoff, double devH, double devL, int stdDevPer)
		{
			if (cacheSVAPO != null)
				for (int idx = 0; idx < cacheSVAPO.Length; idx++)
					if (cacheSVAPO[idx].Period == period && cacheSVAPO[idx].Cutoff == cutoff && cacheSVAPO[idx].DevH == devH && cacheSVAPO[idx].DevL == devL && cacheSVAPO[idx].StdDevPer == stdDevPer && cacheSVAPO[idx].EqualsInput(input))
						return cacheSVAPO[idx];
			return CacheIndicator<SVAPO>(new SVAPO(){ Period = period, Cutoff = cutoff, DevH = devH, DevL = devL, StdDevPer = stdDevPer }, input, ref cacheSVAPO);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.TradingRenkoSR TradingRenkoSR(int strength)
		{
			return indicator.TradingRenkoSR(Input, strength);
		}

		public Indicators.TradingRenkoOZS TradingRenkoOZS(int period, int longPeriod, int percent)
		{
			return indicator.TradingRenkoOZS(Input, period, longPeriod, percent);
		}

		public Indicators.SVAPO SVAPO(int period, int cutoff, double devH, double devL, int stdDevPer)
		{
			return indicator.SVAPO(Input, period, cutoff, devH, devL, stdDevPer);
		}


		
		public Indicators.TradingRenkoSR TradingRenkoSR(ISeries<double> input , int strength)
		{
			return indicator.TradingRenkoSR(input, strength);
		}

		public Indicators.TradingRenkoOZS TradingRenkoOZS(ISeries<double> input , int period, int longPeriod, int percent)
		{
			return indicator.TradingRenkoOZS(input, period, longPeriod, percent);
		}

		public Indicators.SVAPO SVAPO(ISeries<double> input , int period, int cutoff, double devH, double devL, int stdDevPer)
		{
			return indicator.SVAPO(input, period, cutoff, devH, devL, stdDevPer);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.TradingRenkoSR TradingRenkoSR(int strength)
		{
			return indicator.TradingRenkoSR(Input, strength);
		}

		public Indicators.TradingRenkoOZS TradingRenkoOZS(int period, int longPeriod, int percent)
		{
			return indicator.TradingRenkoOZS(Input, period, longPeriod, percent);
		}

		public Indicators.SVAPO SVAPO(int period, int cutoff, double devH, double devL, int stdDevPer)
		{
			return indicator.SVAPO(Input, period, cutoff, devH, devL, stdDevPer);
		}


		
		public Indicators.TradingRenkoSR TradingRenkoSR(ISeries<double> input , int strength)
		{
			return indicator.TradingRenkoSR(input, strength);
		}

		public Indicators.TradingRenkoOZS TradingRenkoOZS(ISeries<double> input , int period, int longPeriod, int percent)
		{
			return indicator.TradingRenkoOZS(input, period, longPeriod, percent);
		}

		public Indicators.SVAPO SVAPO(ISeries<double> input , int period, int cutoff, double devH, double devL, int stdDevPer)
		{
			return indicator.SVAPO(input, period, cutoff, devH, devL, stdDevPer);
		}

	}
}

#endregion
